"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class CreateRule {
    constructor(md) {
        this.replace = (state) => {
            this.renderComponents(state);
        };
        /**
         * Renders custom JSX components in place of HTML
         * generated from the markdown-it package
         */
        this.renderComponents = (state) => {
            for (let i = 0, tokenLength = state.tokens.length; i < tokenLength; i++) {
                if (state.tokens[i].children) {
                    this.renderComponents({
                        Token: state.Token,
                        tokens: state.tokens[i].children,
                    });
                }
                switch (state.tokens[i].type) {
                    case "link_open":
                        /* eslint-disable-next-line no-case-declarations */
                        const linkToken = new state.Token(state.tokens[i].type, "Hypertext", 1);
                        linkToken.attrPush(["href", state.tokens[i].attrs[0][1]]);
                        if (state.tokens[i].attrs[0][1].substr(0, 4) === "http") {
                            linkToken.attrPush(["target", "_blank"]);
                        }
                        state.tokens[i] = linkToken;
                        break;
                    case "link_close":
                        state.tokens[i] = new state.Token(state.tokens[i].type, "Hypertext", -1);
                        break;
                    case "paragraph_close":
                        state.tokens[i] = new state.Token(state.tokens[i].type, "Typography", -1);
                        break;
                    case "heading_close":
                        state.tokens[i] = new state.Token(state.tokens[i].type, "Heading", -1);
                        break;
                    case "hr":
                        state.tokens[i] = new state.Token(state.tokens[i].type, "Divider", 0);
                        break;
                }
            }
        };
        return this.replace;
    }
}
exports.default = CreateRule;
